/**
 * 
 */
package be.ac.ulb.code.wit.infoh509.tp2;

import java.io.File;
import java.io.IOException;

import javax.xml.XMLConstants;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.xml.sax.SAXException;

/**
 * @author Francois Picalausa
 *
 */
public class XSDValidate {

	
    public static void main(String[] args) throws SAXException, IOException {
        if (args.length != 2) {
        	System.out.println("XSDValidate <schema> <xml-document>");
        	return;
        }
    	
    	SchemaFactory factory 
         = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
        File schemaLocation = new File(args[0]);
        Schema schema = factory.newSchema(schemaLocation);
        Validator validator = schema.newValidator();
        validator.setErrorHandler(new ForgivingErrorHandler());
        
        Source source = new StreamSource(args[1]);
        
        try {
            validator.validate(source);
        }
        catch (SAXException ex) {
            System.out.println("Error validating " + args[0]);
            System.out.println(ex.getMessage());
        }  
	}
}
